:- include('clpFD.pl').

test:-
    write('test 1'), nl, 
    findall(X-Y, minimise(supln(X,Y+5),X), L),
    L == [5-0] -> 
    fail ; !, fail.
test:-
    write('test 2'), nl, 
    (length(L1, 3), findall(L1, minimise(member(X,L1),X), L) -> true),
    get_var(L, Vars), length(Vars, 6), L = [[0,_,_],[_,0,_],[_,_,0]] ->
    fail ; !, fail.
test:-
    write('test 3'), nl, 
    (length(L1, 3), findall(L1,(supln(X,5),minimise(member(X,L1),X)), L) -> true),
    get_var(L, Vars), length(Vars, 6), L = [[5,_,_],[_,5,_],[_,_,5]] ->
    fail ; !, fail.
test:-
    write('test 4'), nl, 
    (findall(X, minimise(member(X,[5,3,7,2,4,3]),X), L) -> true),
    L ==  [2] ->
    fail ; !, fail.
test:-
    write('test 5'), nl, 
    (domain([A,B,C,D,E,F,G,H,I,J,K],[1,4]),
    alldifferent([A,J]),alldifferent([J,I]),alldifferent([I,E]),
    alldifferent([E,C]),alldifferent([C,F]),alldifferent([F,G]),
    alldifferent([D,H]),alldifferent([B,D]),alldifferent([K,E]),
    alldifferent([B,I,H,G]),alldifferent([A,G,E]),
    alldifferent([B,H,K]),alldifferent([A,B,C,H]),    
    alldifferent([D,F,J]),
    J.>E, K.>D, K.>F,
    atmost(3,[A,B,C,D,E,F,G,H,I,J,K],1),
    atmost(3,[A,B,C,D,E,F,G,H,I,J,K],2),
    atmost(3,[A,B,C,D,E,F,G,H,I,J,K],3),
    atmost(3,[A,B,C,D,E,F,G,H,I,J,K],4),
    labeling([A,B,C,D,E,F,G,H,I,J,K]) -> true),
    [A,B,C,D,E,F,G,H,I,J,K] == [1,2,3,1,2,2,3,4,1,4,3] ->
    fail ; !, fail.
test:-
    write('test 6'), nl, 
    findall([A,B,D,E,Min,Max],
    (	    
      minimise((B.>=A+5,C.>=B+2,D.>=B+3,E.>=C+5,E.>=D+5),E),
      minmaxvalue(C, Min, Max)
    ), L),
    L == [[0, 5, 8, 13, 7, 8]] ->
    fail ; !, fail.
test:-
    write('test 7'), nl, 
    findall([A,B,C,D,E],
    (
      minimise((B.>=A+5,C.>=B+2,D.>=B+3,E.>=C+5,
		E.>=D+5, (C.>=D+5 ; D.>=C+5)),     E)
    ), L),
    L == [[0, 5 , 7, 12, 17]] ->
    fail ; !, fail.
test:-
    write('OK'), nl.
   