create_mutable(Datum, Mutable):-
    set_bip_name(create_mutable,2),
    var(Mutable) ->
        (nonvar(Datum) ->
            Mutable='$mutable'(Datum);
	    '$pl_err_instantiation');
        '$pl_err_type'(variable, Mutable).

get_mutable(Datum, Mutable):-
    set_bip_name(get_mutable,2),
    nonvar(Mutable) ->
        (functor(Mutable,'$mutable',_) ->
	     Mutable='$mutable'(Datum);
	     '$pl_err_type'(mutable, Mutable));
        '$pl_err_instantiation'.


update_mutable(Datum, Mutable):-
    set_bip_name(update_mutable,2),
    (nonvar(Mutable),nonvar(Datum)) ->
        (functor(Mutable,'$mutable',_) ->
	    setarg(1,Mutable,Datum);
	    '$pl_err_type'(mutable, Mutable));
        '$pl_err_instantiation'.

is_mutable(Mutable):-
    nonvar(Mutable), functor(Mutable,'$mutable',_).

