%%% File : myfreeze.pl %%%


%% declares a new attribute
:-attribute(myfrozen/1).


%% declares verify_myfreeze/3 as an attributes verification handler.
:-verify_attributes_predicate(verify_myfreeze).    

verify_myfreeze(Var, Other, Goal):-
    get_atts(Var, myfrozen(Fa)), !,                % is Var revelant ? 
    (   attributed(Other) ->                       % is Other attributed ?
        (   get_atts(Other, myfrozen(Fb)) ->       % have a pending goal ?
                put_atts(Other, myfrozen((Fa, Fb)))% makes conjunction of goals
        ;       put_atts(Other, myfrozen(Fa))      % rescues the pending goal
        ), Goal=true                               % does nothing after unification
    ;   Goal=Fa).                                  % wakes the pending goal
verify_myfreeze(_, _, true).                       % succeeds if Var is not revelant


%% declares portray_myfreeze/2 as an attribute portraying handler.
:-portray_attributes_predicate(portray_myfreeze).

portray_myfreeze([H|T],L):-
    (get_atts(H, myfrozen(G)) ->                   % is the head revelant ? 
      L = [myfreeze(H, G) | T2];                   % produces output 
      L = T2),                                     % throws the non-revelant vari
    portray_myfreeze(T, T2).                       % treats the tail
portray_myfreeze([],[]).


myfreeze(X, Goal):-
    put_atts(X, myfrozen(Goal)).
