:- include('clpFD.pl').

queens(N, L) :-
        list(N, L),
        domain(L,[1,N]),
        safe(L),
        labeling(L,ff,middle).

safe([]).
safe([X| Y]) :-
        noattack(X, Y),
        safe(Y).

noattack(X, Xs) :-
        noattack(X, Xs, 1).

noattack(X, [], Nb) :- !.
noattack(X, [Y | Ys], Nb) :-
        noteq(X, Y),
        noteq(X, Y+Nb),
        noteq(X, Y-Nb),
        Nb1 is Nb+1,
        noattack(X, Ys, Nb1).

list(0, []) :- !.
list(N, [ _| L] ) :-
        M is N-1,
        list(M, L).

/* *** Example ***

| ?- queens(4,Q).

Q = [2,4,1,3] ? ;

Q = [3,1,4,2] ? ;

no

*/
