%GNU Prolog RH Translation by Remy Haemmerle 2002

/*
 **********************************************************************
 *
 *      CLP(R) Version 2.0	(Example Programs Release)
 *	(C) Copyright, March 1986, Monash University
 *
 **********************************************************************
 */

% 
% The rule below describes the relationship between two complex numbers 
% and their product. The goal        ?- go         uses the rule
% first to multiply two complex numbers, and then to divide one by another,
% in two different ways.
%

zmul(c(R1,I1),c(R2,I2),c(R3,I3)) :-
	{R3 = R1 * R2 - I1 * I2} ,
	{I3 = R1 * I2 + R2 * I1} .

go :- 	zmul(c(1.0,1.0),c(2.0,2.0),Z),
	zmul(c(1.0,1.0),Y,c(0.0,4.0)),
	zmul(X,c(2.0,2.0),c(0.0,4.0)),
	nl,
	format(" X = ",[]),
	write(X),
	nl,
	format(" Y = ",[]),
	write(Y),
	nl,
	format(" Z = ",[]),
	write(Z),
	nl.

% Answer:
%   X = c(1, 1)
%   Y = c(2, 2)
%   Z = c(0, 4)

:-initialization(format("\n>>> Sample goal: go/0\n", [])).
