%GNU Prolog RH Translation by Remy Haemmerle 2002

/*
 **********************************************************************
 *
 *      CLP(R) Version 2.0	(Example Programs Release)
 *	(C) Copyright, March 1986, Monash University
 *
 **********************************************************************
 */

%
% Simple recursive formulation of fibonacci numbers.
% The goal      ?- go       shows how the definition can be used for 
% both finding a a fibonacci number given its index, and finding the index 
% of a given fibonacci number.
%

fib(0.0, 1.0).
fib(1.0, 1.0).
fib(N, _X) :-
        {_X = X1 + X2},
        clpr_epsilon(E),
	{N >= 1+E},
        {_N1 = N - 1},
        {_N2 = N - 2},
	fib(_N1, X1), 
	fib(_N2, X2).

go:- 	fib(10.0, Z), 
	format("forward: fib(10) = ~p\n",[Z]),
	fib(Y, Z),
	format("backward: fib(~p) = ~p\n",[Y,Z]),!.

% Answer:
%  forward: fib(10) = 89
%  backward: fib(10) = 89

:-initialization(format("\n>>> Sample goal: go/0\n", [])).
