#!/bin/bash


for i in `ls *.pl | grep -v 'queens.pl' |
                    grep -v 'array.pl' |
                    grep -v 'bdiag.pl'`
    do 
	echo -n -e `basename $i .pl` '\t(nat) : '
	if ! gplc $i -o a.out --no-top-level  
	    then echo compilation fails; exit 1
	fi
	if ./a.out 2>&1 | grep -q -i 'error\|warning'
	    then echo FAIL; exit 1
	fi 
	echo PASS
	echo -n -e `basename $i .pl` '\t(b-c) : '
	if  gprolog --query-goal "['$i'], !, halt(0)" 2>&1 |
	    grep  -q -i 'error\|warning' 
	    then  echo FAIL; exit 1
	fi 
	echo PASS
done 
echo  -n -e 'queens (+.fd) \t:'
if ! gplc queens.pl queens_fd.fd -o a.out --no-top-level  
	    then echo compilation fails; exit 1
	fi
	if ./a.out 2>&1 | grep -q -i 'error\|warning'
	    then echo FAIL; exit 1
	fi 
	echo PASS
fi

