/*-------------------------------------------------------------------------* 
 * GNU Prolog                                                              * 
 *                                                                         * 
 * Part  : Prolog attributes engine                                        * 
 * File  : attributes.h                                                    * 
 * Descr.: attributes manipulatiopn tools  - header file                   * 
 * Author: Remy Haemmerle                                                  * 
 *                                                                         * 
 * Copyright (C) 2002 INRIA, Remy Haemmerle                                * 
 *                                                                         * 
 * GNU Prolog is free software; you can redistribute it and/or modify it   * 
 * under the terms of the GNU General Public License as published by the   * 
 * Free Software Foundation; either version 2, or any later version.       * 
 *                                                                         * 
 * GNU Prolog is distributed in the hope that it will be useful, but       * 
 * WITHOUT ANY WARRANTY; without even the implied warranty of              * 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU        * 
 * General Public License for more details.                                * 
 *                                                                         * 
 * You should have received a copy of the GNU General Public License along * 
 * with this program; if not, write to the Free Software Foundation, Inc.  * 
 * 59 Temple Place - Suite 330, Boston, MA 02111, USA.                     * 
 *-------------------------------------------------------------------------*/

#ifndef _ATTRIBUTES_H
#define _ATTRIBUTES_H

/*---------------------------------*
 * Constants                       *
 *---------------------------------*/

#define MAX_NB_ATTS                          32
#define ACTIVE_ATTRIBUTE(_Mask, _Index)      (_Mask & (1 << _Index))        


extern WamWord n_attributes;

/*---------------------------------*
 * Function Prototypes             *
 *---------------------------------*/

Bool get_nb_atts(WamWord n);
Bool inc_nb_atts();
/*
void add_verify_atts_handler(WamWord Handle);
Bool get_verify_atts_handles(WamWord Handles);
*/
Bool attributed(WamWord s_word);
Bool put_attributes(WamWord s_word, WamWord Index, WamWord Attr);
Bool get_attributes(WamWord s_word, WamWord Index, WamWord Attr);

Bool force_binding(WamWord s_word, WamWord other);

#endif /* _ATTRIBUTES_H */
