/*-------------------------------------------------------------------------*
 * GNU Prolog                                                              *
 *                                                                         *
 * Part  : Attributes Engine                                               *
 * File  : tools.pl                                                        *
 * Descr.: generic tools                                                   *
 * Author: Remy Haemmerle                                                  *
 *                                                                         *
 * Copyright (C) 2001-2002 Remy Haemmerle                                  *
 *                                                                         *
 * GNU Prolog is free software; you can redistribute it and/or modify it   *
 * under the terms of the GNU General Public License as published by the   *
 * Free Software Foundation; either version 2, or any later version.       *
 *                                                                         *
 * GNU Prolog is distributed in the hope that it will be useful, but       *
 * WITHOUT ANY WARRANTY; without even the implied warranty of              *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU        *
 * General Public License for more details.                                *
 *                                                                         *
 * You should have received a copy of the GNU General Public License along *
 * with this program; if not, write to the Free Software Foundation, Inc.  *
 * 59 Temple Place - Suite 330, Boston, MA 02111, USA.                     *
 *-------------------------------------------------------------------------*/

'$use_tools'.

:- built_in.


ground(Term) :- 
    set_bip_name(ground, 1),
    '$call_c_test'('Is_Ground'(Term)).

term_variables(X, L):-
    get_var(X, L),
    sort(L).

get_var(X,[X]):-generic_var(X), !. 
get_var([],[]):-!.
get_var([X|F],L):-!,
	get_var(X,L1),
        get_var(F,L2),
        append(L1,L2,L).
get_var(X,L):-compound(X),!,
	 X=..[_|L2],
	 get_var(L2,L).
get_var(_,[]).
