/*-------------------------------------------------------------------------* 
 * GNU Prolog                                                              * 
 *                                                                         * 
 * Part  : Prolog attributes engine                                        * 
 * File  : wake.h                                                          * 
 * Descr.: wake engine  - header file                                      * 
 * Author: Remy Haemmerle                                                  * 
 *                                                                         * 
 * Copyright (C) 2002 INRIA, Remy Haemmerle                                * 
 *                                                                         * 
 * GNU Prolog is free software; you can redistribute it and/or modify it   * 
 * under the terms of the GNU General Public License as published by the   * 
 * Free Software Foundation; either version 2, or any later version.       * 
 *                                                                         * 
 * GNU Prolog is distributed in the hope that it will be useful, but       * 
 * WITHOUT ANY WARRANTY; without even the implied warranty of              * 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU        * 
 * General Public License for more details.                                * 
 *                                                                         * 
 * You should have received a copy of the GNU General Public License along * 
 * with this program; if not, write to the Free Software Foundation, Inc.  * 
 * 59 Temple Place - Suite 330, Boston, MA 02111, USA.                     * 
 *-------------------------------------------------------------------------*/

#ifndef _WAKE_H
#define _WAKE_H

/*---------------------------------*
 * Constants                       *
 *---------------------------------*/

#define WAKE_DEAMON  X77616B655F6461656D6F6E
#define $USE_ATTR    X247573655F61747472696275746573

#define CONTINUE_AFTER_WAKE     X24636F6E74696E75655F61667465725F77616B65
#define BC_CONTINUE_AFTER_WAKE  X2462635F636F6E74696E75655F61667465725F77616B65


#define Test_ATT_STATUS()   if (!WAKE_STATUS) return FALSE


/*---------------------------------*
 * Function Prototypes             *
 *---------------------------------*/

extern WamWord Wake_Status;

Prolog_Prototype($USE_ATTR, 0);
Prolog_Prototype(WAKE_DEAMON, 0);
Prolog_Prototype(CONTINUE_AFTER_WAKE,0);
Prolog_Prototype(BC_CONTINUE_AFTER_WAKE,0);

void Wake(int n, CodePtr next_inst) FC;
CodePtr Restore_Env() FC;
void Wake_Push(WamWord var, WamWord other);

Bool Get_Wake_Satck(WamWord stack);
void Delete_Wake_Stack();


void Attributes_On();
void Attributes_Off();

#endif /* _WAKE_H */
