/*-------------------------------------------------------------------------* 
 * GNU Prolog                                                              * 
 *                                                                         * 
 * Part  : Prolog attributes engine                                        * 
 * File  : wake.pl                                                         * 
 * Descr.: wake engine - prolog file                                       * 
 * Author: Remy Haemmerle                                                  * 
 *                                                                         * 
 * Copyright (C) 2002 INRIA, Remy Haemmerle                                * 
 *                                                                         * 
 * GNU Prolog is free software; you can redistribute it and/or modify it   * 
 * under the terms of the GNU General Public License as published by the   * 
 * Free Software Foundation; either version 2, or any later version.       * 
 *                                                                         * 
 * GNU Prolog is distributed in the hope that it will be useful, but       * 
 * WITHOUT ANY WARRANTY; without even the implied warranty of              * 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU        * 
 * General Public License for more details.                                * 
 *                                                                         * 
 * You should have received a copy of the GNU General Public License along * 
 * with this program; if not, write to the Free Software Foundation, Inc.  * 
 * 59 Temple Place - Suite 330, Boston, MA 02111, USA.                     * 
 *-------------------------------------------------------------------------*/

:-built_in.

'$use_wake'.

daemon(Var, Other, [], G):-!,
    '$verif_frozen'(Var, Other, G).
%	G=true.
daemon(Var, Other, [H|L], (G1,G2)):-
     call_with_args(H, Var, Other, G1),
     daemon(Var, Other, L, G2).

wake_daemon([]):-!.
wake_daemon([Var, Other |T]):-(
    Var == Other, !; 
    g_read('$verify_attributes_predicates', Functors),
    daemon(Var, Other, Functors, Goals),
%			       write(Functors),nl,
%			       write(Goals), nl,
    force_binding(Var, Other),
    call(Goals)),
    wake_daemon(T).



wake_daemon:-
    set_bip_name(wake_deamon,0),
    ('$call_c_test'('Get_Wake_Stack'(Stack)) ->
         wake_daemon(Stack)
    ;
        '$pl_err_syntax'('wake deamon problem')).

attributes_on:-
    '$call_c'('Attributes_On').

attributes_off:-  
    '$call_c'('Attributes_Off').
