:-initialization(go).

:-include('filtered_preds.pl').

:-dynamic(disable/0).

%disable.

go:-
	disable,
	repeat,
	read(T),
	(
	  T = end_of_file, !, halt(0)
	;
	  my_write(T),
	  fail
	),
	halt(1).
	  

go:-
	repeat,
	read(T1),
	(
	  T1 = end_of_file, !, halt(0)
	;
	  translate(T1, T2),
	  my_write(T2),
	  fail
	),
	halt(1).
	  


translate(predicate(F1/A, PlLine, StaDyn, PubPriv, UsBplBfd, Instructions1),
	  predicate(F2/A, PlLine, StaDyn, PubPriv, UsBplBfd, Instructions2)):-
	(
	  must_be_filtered(F1, A) ->
	  atom_concat('$filtered_', F1, F2)
	;
	  F1 = F2
	),
	translateInsts(Instructions1, Instructions2).
translate(T, T):-
	functor(T, file_name, 1).

translateInsts([], []).
translateInsts([H1|T1], [H2|T2]):-
	translateInst(H1, H2),
	translateInsts(T1, T2).



translateInst(call(F1/A), call(F2/A)):-!,
	(
	  must_be_filtered(F1, A) ->
	  atom_concat('$filtered_', F1, F2)
	;
	  F1 = F2
	).
translateInst(execute(F1/A), execute(F2/A)):-!,
	(
	  must_be_filtered(F1, A) ->
	  atom_concat('$filtered_', F1, F2)
	;
	  F1 = F2
	).
translateInst(I, I).



my_write(predicate(F/A, PlLine, StaDyn, PubPriv, UsBplBfd, Code)):-
	format('~n~npredicate(~q,~d,~a,~a,~a,', [F/A, PlLine, StaDyn, PubPriv, UsBplBfd]),
	write_code(Code, _),
	write(']).'),
	nl.

my_write(file_name(F)):-
	writeq(file_name(F)), write('.'), nl.

write_code([], _).
write_code([H|T], First) :-
	write_inst(H, First),
	write_code(T, First).
write_inst(WamInst, First) :-
	(   var(First) ->
	    Car = '[',
	    First = f
	;   Car = (',')
	),
	format('~a~n\t', [Car]),
	writeq(WamInst).



/*
emit_wam_code([], _).

emit_wam_code([WamInst|WamCode], First) :-
	%write(toto(WamInst ,  WamCode)),
	emit_wam_code(WamInst, First),              % for nested code
	emit_wam_code(WamCode, First), !.

%emit_wam_code(WamInst, First) :-
%	special_form(WamInst, WamInst1),
%	emit_wam_code(WamInst, First).

%emit_wam_code(WamInst, _, _) :-
%	g_read(keep_void_inst, KeepVoidInst),
%	dummy_instruction(WamInst, KeepVoidInst), !.

emit_wam_code(WamInst, First) :-
	WamInst = label(_), !,
	(   var(First) ->
	    Car = '[',
	    First = f
	;   Car = (',')
	),
	format('~a~n~n', [Car]),
	emit_one_inst(WamInst).

emit_wam_code(WamInst, First) :-
	(   var(First) ->
	    Car = '[',
	    First = f
	;   Car = (',')
	),
	format('~a~n    ', [Car]),
	emit_one_inst(WamInst).




emit_one_inst(WamInst) :-
	atom(WamInst), !,
	writeq(WamInst).

emit_one_inst(WamInst) :-
	functor(WamInst, F, N),
	writeq(F),
	emit_args(0, N, WamInst),
	write(')').

emit_args(N, N, _, _) :-
	!.

emit_args(I, N, WamInst) :-
	I1 is I + 1,
	(   I1 = 1 ->
	    put_char('(')
	;   put_char(',')
	),
	arg(I1, WamInst, A),
	emit_one_arg(A),
	emit_args(I1, N, WamInst).

emit_one_arg([X|L]) :-
	length(L, N),		% split long lists
	N > 30,
	!,
	put_char('['),
%	line_position(Stream, P),
	write_term(X, [quoted(true), priority(999)]),
	emit_list(L, 0).

emit_one_arg(A) :-
	writeq(A).




emit_list([], _) :-
	put_char(']').

emit_list([X|L], P) :-
	format(',~n~*c', [P, 0' ]),
	write_term(X, [quoted(true), priority(999)]),
	emit_list(L, P).
*/