/*-------------------------------------------------------------------------*
 * GNU Prolog                                                              *
 *                                                                         *
 * Part  : CLP(R) Engine                                                   *
 * File  : clpr.h                                                          *
 * Descr.: CLP(R) solver interface - header file                           *
 * Author: Remy Haemmerle                                                  *
 *                                                                         *
 * Copyright (C) 2001-2002 INRIA, Remy Haemmerle                           *
 *                                                                         *
 * GNU Prolog is free software; you can redistribute it and/or modify it   *
 * under the terms of the GNU General Public License as published by the   *
 * Free Software Foundation; either version 2, or any later version.       *
 *                                                                         *
 * GNU Prolog is distributed in the hope that it will be useful, but       *
 * WITHOUT ANY WARRANTY; without even the implied warranty of              *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU        *
 * General Public License for more details.                                *
 *                                                                         *
 * You should have received a copy of the GNU General Public License along *
 * with this program; if not, write to the Free Software Foundation, Inc.  *
 * 59 Temple Place - Suite 330, Boston, MA 02111, USA.                     *
 *-------------------------------------------------------------------------*/


#ifndef _CLPR_H
#define _CLPR_H


#include "incremental.h"
#include "gprolog.h"


/*---------------------------------*
 * Constants                       *
 *---------------------------------*/

#define CLPR_VAR_MAX          2048
#define INITITAL_CLPR_VARS     128

/*---------------------------------*/
/* Global Variables                */
/*---------------------------------*/


/*---------------------------------*/
/* Function Prototypes             */
/*---------------------------------*/

void CLPR_Init();

void CLPR_New_Constraint(WamWord type); // 0 <=> EQ ; 1 <=> LE
void CLPR_New_Variable(WamWord index, WamWord var);

void CLPR_Add_Const(WamWord flt);
void CLPR_Add_Monom(WamWord index, WamWord mult);
void CLPR_Add_Monom_to_Cost(WamWord index, WamWord mult);
void CLPR_cost_to_zero();

void CLPR_Del_Constraint();

Bool CLPR_Test();
Bool CLPR_Miniminization(WamWord res);

/* Bool CLPR_Test_constant(WamWord index, WamWord Value); */
void CLPR_Try_to_detect_instanciation();
Bool CLPR_test_instanciated(WamWord index);

Bool CLPR_Portray(WamWord Res);

Bool Finite(WamWord N);


#ifdef M_win32
#define finite(X) _finite(X)
#endif


#endif  /* _CLPR_H */
