/*-------------------------------------------------------------------------*
 * GNU Prolog                                                              *
 *                                                                         *
 * Part  : Prolog to WAM compiler                                          *
 * File  : attributes.pl                                                   *
 * Descr.: attributes macros                                               *
 * Author: Remy Haemmerle                                                  *
 *                                                                         *
 * Copyright (C) 2002 INRIA, Remy Haemmerle                                *
 *                                                                         *
 * GNU Prolog is free software; you can redistribute it and/or modify it   *
 * under the terms of the GNU General Public License as published by the   *
 * Free Software Foundation; either version 2, or any later version.       *
 *                                                                         *
 * GNU Prolog is distributed in the hope that it will be useful, but       *
 * WITHOUT ANY WARRANTY; without even the implied warranty of              *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU        *
 * General Public License for more details.                                *
 *                                                                         *
 * You should have received a copy of the GNU General Public License along *
 * with this program; if not, write to the Free Software Foundation, Inc.  *
 * 59 Temple Place - Suite 330, Boston, MA 02111, USA.                     *
 *-------------------------------------------------------------------------*/

:-include('../Attributes/atts_declaration.pl').

expand_put_atts(Var, Att, G):-
    generic_var(Var) -> (
        nonvar(Att),
        functor(Att, F, N),
        '$get_static_attr_info'(F,N,I) ->
	    (N == 1 ->
	         arg(1,Att,A);
                 A = Att),
            G='$put_atts'(Var, I, A)
	;
            G=put_atts(Var, Att))
    ;
         warn('explicite put_attr will fail : first parameter instancied',[]),
         G=put_atts(Var, Att).
   
expand_get_atts(Var, Att, G):-
    generic_var(Var) -> (
        nonvar(Att),
        functor(Att, F, N), 
        '$get_static_attr_info'(F,N,I) ->
	    (N == 1 ->
	         arg(1,Att,A);
                 A = Att), 
            G='$get_atts'(Var, I, A)
	;
            G=get_atts(Var, Att))
    ;
         warn('explicite get_attr will fail : first parameter instancied',[]),
         G=put_atts(Var, Att).
