; GNU Prolog WIN32 installation script for Inno Setup

[Setup]
AppName=GNU Prolog RH
AppVerName=GNU Prolog version @VERSION@
AppVersion=@VERSION@
AppPublisher=Rmy Haemmerl
AppPublisherURL=http://contraintes.inria.fr/~haemmerl/gprolog-rh
AppSupportURL=http://contraintes.inria.fr/~haemmerl/gprolog-rh
AppUpdatesURL=http://contraintes.inria.fr/~haemmerl/gprolog-rh
DefaultDirName={sd}\GNU-Prolog-RH
DefaultGroupName=GNU Prolog RH
AllowNoIcons=yes
;AlwaysCreateUninstallIcon=yes
SourceDir=C:\cygwin\tmp\gprolog_win32
OutputDir=C:\cygwin\tmp
OutputBaseFileName=setup-gprolog-@VERSION@

; TO DO: create an association for .pl and .pro files
; ChangesAssociations=yes

; uncomment the following line if you want your installation to run on NT 3.51 too.
; MinVersion=4,3.51

[Tasks]
Name: "desktopicon"; Description: "Create a &desktop icon"; GroupDescription: "Additional icons:"; MinVersion: 4,4

[Files]
Source: "*.*"; DestDir: "{app}"; Flags: ignoreversion 
Source: "bin\*.*"; DestDir: "{app}\bin"; Flags: ignoreversion 
Source: "lib\*.*"; DestDir: "{app}\lib"; Flags: ignoreversion 
;Source: "lib\*.dll"; DestDir: "{app}\bin"; Flags: ignoreversion 
Source: "include\*.*"; DestDir: "{app}\include"; Flags: ignoreversion 
Source: "doc\*.*"; DestDir: "{app}\doc"; Flags: ignoreversion 
Source: "doc\Html\*.*"; DestDir: "{app}\doc\Html"; Flags: ignoreversion 
Source: "ExamplesPl\*.*"; DestDir: "{app}\ExamplesPl"; Flags: ignoreversion 
Source: "ExamplesFD\*.*"; DestDir: "{app}\ExamplesFD"; Flags: ignoreversion 
Source: "ExamplesC\*.*"; DestDir: "{app}\ExamplesC"; Flags: ignoreversion 
Source: "ExamplesATT\*.*"; DestDir: "{app}\ExamplesATT"; Flags: ignoreversion 
Source: "ExamplesCLPR\*.*"; DestDir: "{app}\ExamplesCLPR"; Flags: ignoreversion 
Source: "c:\Program Files\HTML Help Workshop\REDIST\HHUPD.EXE"; DestDir: "{tmp}"; OnlyBelowVersion : 5.0, 5.0


[INI]
Filename: "{app}\gprolog-rh.url"; Section: "InternetShortcut"; Key: "URL"; String: "http://contraintes.inria.fr/~haemmerl/gprolog-rh"

[Icons]
Name: "{group}\GNU Prolog"; Filename: "{app}\bin\gprolog.exe"
Name: "{group}\Help"; Filename: "{app}\doc\Html\manual.chm"
Name: "{group}\Html Manual"; Filename: "{app}\doc\Html\index.html"
Name: "{group}\The GNU Prolog RH Web Site"; Filename: "{app}\gprolog.url"
Name: "{group}\Uninstall GNU Prolog"; Filename: "{uninstallexe}"

Name: "{userdesktop}\GNU Prolog"; Filename: "{app}\bin\gprolog.exe"; MinVersion: 4,4; Tasks: desktopicon

[Registry]
Root: HKCU; Subkey: "Software\GnuProlog"; ValueType: string; ValueName: "Version"; ValueData: "@VERSION@"
Root: HKCU; Subkey: "Software\GnuProlog"; ValueType: string; ValueName: "RootPath"; ValueData: "{app}"

[Run]
Filename: "{app}\bin\create_bat.exe"; Parameters: """{sd}"" ""{app}"""; Description: "Create {sd}\gprologvars.bat";
Filename: "{app}\bin\gprolog.exe"; Description: "Launch GNU Prolog"; Flags: nowait postinstall skipifsilent
Filename : "{tmp}\HHUPD.EXE"; OnlyBelowVersion : 5.0, 5.0

[UninstallDelete]
Type: files; Name: "{app}\gprolog-rh.url"


