:-include('filtered_preds.pl').

:-initialization(go).

go:-
	writeq(('$use_filtered_builtin')), write('.'), nl,
	gene(Clause),
	writeq(Clause), write('.'), nl,
	fail.

go:-format('\
\'$filter_list\'(X, X, [], []) :-var(X), !.\n\
\'$filter_list\'(X, Y, X, Y) :-attributed(X), !.\n\
\'$filter_list\'(A, B, C, D) :-\'$filter_list2\'(A, B, C, D).\n\
\'$filter_list2\'([], [], [], []):-!.\n\
\'$filter_list2\'([X|T1], [Y|T2], Sub1, Sub2):-\n\
	(\n\
	  attributed(X) ->\n\
	  Sub1 = [X|Sub1T], Sub2 = [Y|Sub2T]\n\
	;\n\
	  X = Y, Sub1 = Sub1T, Sub2 = Sub2T\n\
	),\n\
	\'$filter_list2\'(T1, T2, Sub1T, Sub2T).', []),
	
	halt(0).

gene(Clause):-
	filtered_pred(Spec),
	gene_pred(Spec, Clause).

gene(Clause):-
	filtered_pred(F, N),
	functor(Spec, F, N), Spec =.. [_|Args],
	plus(Args),
	gene_pred(Spec, Clause).


plus([]).
plus([+|T]):-plus(T).


gene_pred(Spec, Clause):-
	Spec =.. [FH | Args],
	process_arg(Args, ArgsH, ArgsB,  Before, After),
	Head =.. [FH | ArgsH],
	atom_concat('$filtered_', FH, FB), Body=.. [FB | ArgsB],
	Clause = ((Head :- Before, Body, After)).

process_arg([], [], [], true, true).
process_arg([+| T],[X | TX], [Y | TY], Before, After):-!,
	process_arg(T, TX, TY, BeforeT, AfterT),
	apend_goal((attributed(X) -> true; X = Y), BeforeT, Before),
	apend_goal(X = Y, AfterT, After).
process_arg([*| T],[X | TX], [Y | TY], Before, After):-!,
	process_arg(T, TX, TY, BeforeT, AfterT),
	apend_goal('$filter_list'(X, Y, SubListX, SubListY), BeforeT, Before),
	apend_goal(SubListX=SubListY, AfterT, After).
process_arg([_|T],[X | TX], [X | TY], Before, After):-
	process_arg(T, TX, TY, Before, After).

apend_goal(X, true, X):-!.
apend_goal(X, Y, (X,Y)).





